## jsoncons 1.3.1

=== debian/changelog ===
jsoncons (1.3.1-1) unstable; urgency=medium

  * d/tests: disable autopkgtest on riscv64 since being too slow.
  * New upstream version 1.3.1.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Sun, 13 Apr 2025 15:26:00 +0800

jsoncons (1.3.0-2) unstable; urgency=medium

  * d/patches: add patch to disable flaky tests on some architectures

 -- Shengqi Chen <harry@debian.org>  Sat, 12 Apr 2025 23:33:56 +0800

jsoncons (1.3.0-1) unstable; urgency=medium

  * Initial packaging for jsoncons (closes: #1100410).

 -- Shengqi Chen <harry@debian.org>  Thu, 13 Mar 2025 23:21:40 +0800
