=== debian/changelog ===
jsoncons (1.3.2-1) unstable; urgency=medium

  * New upstream version 1.3.2.

 -- Shengqi Chen <harry@debian.org>  Fri, 02 May 2025 16:16:15 +0800
