=== debian/watch ===
version=4
https://github.com/danielaparker/jsoncons/tags .*/v?(\d.*)@ARCHIVE_EXT@
