## jsoncons 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.15)
 
 project(jsoncons CXX)
 
@@ -45,14 +45,14 @@
 
 # Makes the project importable from the build directory
 export(EXPORT ${PROJECT_NAME}-targets
+       NAMESPACE jsoncons::
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
 
 install(DIRECTORY ${JSONCONS_INCLUDE_DIR}/jsoncons
                   ${JSONCONS_INCLUDE_DIR}/jsoncons_ext
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
-# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
-set(JSONCONS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for jsonconsConfig.cmake")
+set(JSONCONS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for jsonconsConfig.cmake")
 
 configure_package_config_file(cmake/Config.cmake
                               "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
@@ -60,7 +60,7 @@
 
 # jsoncons is header-only and does not depend on the architecture.
 
-if (${CMAKE_VERSION} VERSION_LESS "3.14.0")
+if (CMAKE_VERSION VERSION_LESS "3.14.0")
    write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                     VERSION ${${PROJECT_NAME}_VERSION}
                                     COMPATIBILITY AnyNewerVersion)
@@ -76,5 +76,6 @@
         DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})
 install(EXPORT ${PROJECT_NAME}-targets
         FILE ${PROJECT_NAME}Targets.cmake
+        NAMESPACE jsoncons::
         DESTINATION ${JSONCONS_CMAKECONFIG_INSTALL_DIR})
