=== debian/changelog ===
jsoncons (1.4.0-1) unstable; urgency=medium

  * d/watch: switch to uscan version 5.
  * New upstream version 1.4.0.
  * d/patches: disable -Werror=maybe-uninitialized in tests (closes: #1114156).
  * d/libjsoncons-dev.install: change cmake config install location to
    /usr/share/cmake.

 -- Shengqi Chen <harry@debian.org>  Fri, 12 Sep 2025 21:38:49 +0800
