=== debian/control ===
Source: jsoncons
Section: utils
Priority: optional
Standards-Version: 4.7.2
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build
Homepage: https://danielaparker.github.io/jsoncons/
Vcs-Git: https://salsa.debian.org/harry/jsoncons.git
Vcs-Browser: https://salsa.debian.org/harry/jsoncons
Rules-Requires-Root: no

Package: libjsoncons-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ header-only library for JSON and alike formats (development files)
 jsoncons is a C++, header-only library for constructing JSON and JSON-like data
 formats, including JSON Pointer, JSON Patch, JSON Schema, JSONPath, JMESPath,
 CSV, MessagePack, CBOR, BSON, UBJSON.
 .
 This package contains the development files.

Package: libjsoncons-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ header-only library for JSON and alike formats (documentation)
 jsoncons is a C++, header-only library for constructing JSON and JSON-like data
 formats, including JSON Pointer, JSON Patch, JSON Schema, JSONPath, JMESPath,
 CSV, MessagePack, CBOR, BSON, UBJSON.
 .
 This package contains the documentation and examples of libjsoncons.
