=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake+ninja

# this package is not arch-depent, so no need for host triple
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=/usr/lib
