=== debian/watch ===
Version: 5
Template: GitHub
Owner: danielaparker
Project: jsoncons
