=== debian/changelog ===
jsoncons (1.4.3-2) unstable; urgency=medium

  * d/rules: fix false positive of GCC and permission issue in source.
  * d/control: do not build libjsoncons-doc with nodoc profile.

 -- Shengqi Chen <harry@debian.org>  Wed, 19 Nov 2025 16:44:21 +0800

jsoncons (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3.
  * d/patches: remove workaround for compiler warnings.

 -- Shengqi Chen <harry@debian.org>  Thu, 23 Oct 2025 16:59:46 +0800
