=== debian/control ===
--- 
+++ 
@@ -28,6 +28,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
+Build-Profiles: <!nodoc>
 Depends: ${misc:Depends}
 Description: C++ header-only library for JSON and alike formats (documentation)
  jsoncons is a C++, header-only library for constructing JSON and JSON-like data
