=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# https://github.com/danielaparker/jsoncons/issues/645
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=free-nonheap-object

%:
	dh $@ --buildsystem=cmake+ninja

# this package is not arch-depent, so no need for host triple
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=/usr/lib

execute_before_dh_install:
	# https://github.com/danielaparker/jsoncons/issues/657
	chmod a-x examples/build/cmake/CMakeLists.txt
