=== debian/changelog ===
jsoncons (1.5.0-2) unstable; urgency=medium

   * Add patch to fix autopkgtests on non-amd64 architectures.

 -- Shengqi Chen <harry@debian.org>  Mon, 22 Dec 2025 13:22:00 +0800

jsoncons (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0.

 -- Shengqi Chen <harry@debian.org>  Wed, 10 Dec 2025 13:52:54 +0800
